<template>
  <div @keyup.enter="sendDataOfUser">
    <div class="white-block" ref="start">
      <div class="padding">
        <h3>Личные данные</h3>
      </div>
      <hr/>
      <div class="padding">
        <birthday ref="InfoAboutBirth" @error="errorHandler"></birthday>
      </div>
    </div>
    <passport-information ref="PassportInformation" @error="errorHandler"></passport-information>
    <registration-address ref="RegistrationAddress" block></registration-address>
    <div class="center">
      <!--<button @click='sendDataOfUser' :disabled="!agree">Продолжить</button>-->
      <!--<div v-if="allFields" class="warning-red-block" style="padding-bottom: 20px;">-->
        <!--<div class="close" @click="allFields = false"></div>-->
        <!--Не заполнены обязательные поля. Пожалуйста, заполните их и снова нажмите кнопку продолжить-->
      <!--</div>-->
      <error-block :errors="errors" @clear="errors = []"></error-block>
      <!--<vuex-error-block :errorsFields="['дата рождения', 'bPlace', 'gender', 'passport', 'passportDivisionCode', 'дата выдачи', 'passportIssuedBy', 'snils',
      'regionRegistration', 'houseRegistration', 'индекс'
      ]"></vuex-error-block>-->
      <warning-message></warning-message>
      <button @click='sendDataOfUser'
              :disabled="$interface.buttonLoading"
              :class="{button_loading: $interface.buttonLoading}">Продолжить</button>
    </div>
  </div>
</template>

<script>
  import Birthday from '@/components/User/PersonalInformation/Birthday'
  import PassportInformation from '@/components/User/PassportInformation'
  import RegistrationAddress from '@/components/User/Address'
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import {SET_USER_LOCATION} from '@/store/mutation-types'
  import WarningMessage from '@/components/AuxiliaryWindows/WarningMessage'
  import Inn from '@/mixins/Inn.js';
  import ErrorLog from '@/mixins/ErrorLog.js';

  export default {
    name: 'second-page',
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      IndicatorRegistration,
      Inn,
      ErrorLog
    ],
    components: {
      Birthday,
      PassportInformation,
      RegistrationAddress,
      WarningMessage
    },
    data () {
      return {
        errors: [],
        allFields: false,
        userNotUnique: false
      }
    },
    computed: {
      agree () {
        return this.$validate.step2;
      }
    },
    methods: {
      errorHandler (data) {
        if (data.key === 'userNotUnique') {
          this.userNotUnique = data.value
        }
      },
      getLocation () {
        navigator.geolocation.getCurrentPosition(function (location) {
          let geoCords = {
            latitude: location.coords.latitude,
            longitude: location.coords.longitude
          }
          // this.$store.commit(SET_USER_LOCATION, geoCords)
          // console.log(location.coords.latitude)
          // console.log(location.coords.longitude)
          // console.log(location.coords.accuracy)
        })
      },
      async sendDataOfUser () {
        if (this.userNotUnique) {
          this.$helpers.focus();
            this.$toastr.error(`Указанные данные уже зарегистрированны. <a href='#' @click.stop="$router.push('/lk')">Перейдите в личный кабинет</a>`, 'Ошибка');
          return
        }
        let access = this.$refs
        await access.InfoAboutBirth.$validator.validateAll().then((val) => {
          this.$user.validate.step2.birthDate = val
        })
        await access.PassportInformation.$validator.validateAll().then((val) => {
          this.$user.validate.step2.passportInformation = val
        })
        await access.RegistrationAddress.$validator.validateAll().then((val) => {
          this.$user.validate.step2.registrationAddress = val
        })
        // проверка на населенный пункт
        if (!this.$user.address.city && !this.$user.address.settlement) {
          this.$refs.RegistrationAddress.vErrors.add('region', 'Не выбран населенный пункт')
          this.$toastr.error('Не выбран населенный пункт')
          this.$nextTick(() => {
            this.$helpers.focus()
          })
          return
        }
        // проверка на улицу
        if (!this.$user.addressFiases.street_fias_id && !this.$user.address.doNotHaveStreet) {
          this.$toastr.error('Необходимо указать улицу или нажать на галочку "Я подтверждаю, что по моему адресу регистрации улица отсутствует."')
          this.$refs.RegistrationAddress.$refs.doNotHaveStreet.style.color = '#ff6d4a'
          this.allFields = false
          return
        }
        // проверка на заполненость полей
        if (!this.$validate.step2) {
          console.warn('Missed fields', this.$user.validate.step2)
          this.allFields = true
          access.InfoAboutBirth.$validator.validateAll().then((val) => {
            this.$user.validate.step2.birthDate = val
          })
          access.PassportInformation.$validator.validateAll().then((val) => {
            this.$user.validate.step2.passportInformation = val
          })
          access.RegistrationAddress.$validator.validateAll().then((val) => {
            this.$user.validate.step2.registrationAddress = val
          })
          this.$toastr.error('Заполните все обязательные поля', 'Ошибка')

          this.$nextTick(() => {
            this.$helpers.focus();
          })
        } else {
          this.BUTTON_LOADING(true);
          this.allFields = false;
          this.$store.dispatch('CREATE_USER', ['smsCode',
            'mobilePhone',
            'bDay',
            'bPlace',
            'gender',
            'passport',
            'passportDivisionCode',
            'passportDateOfIssue',
            'passportIssuedBy',
            'address.postalCode',
            'address.region',
            'address.city',
            'address.settlement',
            'address.street',
            'address.doNotHaveStreet',
            'address.house',
            'address.geoLat',
            'address.geoLon',
            'address.housing',
            'address.building',
            'address.flat',
            'addressFiases.value',
            'addressFiases.region_fias_id',
            'addressFiases.area_fias_od',
            'addressFiases.city_fias_id',
            'addressFiases.settlement_fias_id',
            'addressFiases.street_fias_id',
            'addressFiases.house_fias_id'])
			  .then(() => {
				  this.$user.regStep = 3;
				  document.location.hash = 'step3';
                  window.Analityc.reg_step2();
				  this.$backend.log({
					  lk_log: 'stats',
					  reg_step: 2,
					  user_hash: this.$user.hash,
					  user_phone: this.$user.mobilePhone.replace(/[^\d]/g, ''),
					  user_name: `${this.$user.lastName} ${this.$user.firstName} ${this.$user.middleName}`
				  });
				  this.sendInnCheck();

			  })
			  .catch(e => {
				  /*передать родительскому компоненту ошибку*/
				  this.$emit('errorResponse', e);
				  let error = '';
				  let user;
				  if(Array.isArray(e.errors)) {
					  error = JSON.stringify(e.errors);
					  // подсвечиваем поля и отправляем ошибку.
					  e.errors.forEach((er) => {
						  this.$errorField(er.code);
					  });
					  const mapper = require('../../../utils/error_mapper/user').default;
					  const errorMap = mapper[e.errors[0].code];
					  if(errorMap) {
						  this.$toastr.error(errorMap.message, 'Ошибка');
						  this.$nextTick(() => {
							  this.$helpers.focus();
						  });
					  } else {
						  this.$toastr.error('Произошла непредвиденная ошибка.', 'Ошибка');
					  }
					  this.$backend.log({
						  lk_log: 'reg_error',
						  step: 2,
						  error,
						  user_hash: this.$user.hash,
						  user_phone: this.$user.mobilePhone.replace(/[^\d]/g, ''),
						  user_name: `${this.$user.lastName} ${this.$user.firstName} ${this.$user.middleName}`
					  });
				  } else {
					  error = e.message;
					  user = this.$user;
					  this.$backend.log({
						  lk_log: 'reg_error',
						  step: 2,
						  error,
						  user,
						  user_hash: this.$user.hash,
						  user_phone: this.$user.mobilePhone.replace(/[^\d]/g, ''),
						  user_name: `${this.$user.lastName} ${this.$user.firstName} ${this.$user.middleName}`
					  });
				  }
			  })
			  .finally(() => {
				  this.BUTTON_LOADING(false);
			  });
        }
      }
    },
    mounted () {
      this.$helpers.scroll(this.$parent.$el);
      this.$store.commit('SET_ERRORS', []);
    }
  }
</script>

<style scoped>

</style>



